
;*** sets 34 text lines, in window and fullscreen
;*** for use in DOS/Win9x only
;*** this is done by setting 480 scan lines
;*** and setting a character set of 14 lines (480/14=34.28)
;*** to generate:
;***    jwasm -mz setm34.asm
;**+ or, alternatively:
;***    ml -c setm34.asm
;***    link setm34.obj; <--- must be 16 bit linker

	.286
	.model small,stdcall

ROWS	equ 34
?DRIVER	equ 1				;insert code to generate driver+exe

	.stack 200h
	.code

	ASSUME DS: _TEXT

if ?DRIVER

IODAT   struct				;structure for dos device drivers
cmdlen  db      ?
unit    db      ?
cmd     db      ?
status  dw      ?
        db      8 dup (?)
media   db      ?
trans   dd      ?
count   dw      ?
start   dw      ?
drive   db      ?
IODAT   ends

	dw 0ffffh
	dw 0ffffh
	dw 8000h				  ;attribute
	dw offset devstrat		  ;device strategy
	dw offset devint		  ;device interrupt
	db 'SETM34#1'			  ;device name 8 chars (use carefully)

saveptr dd 1 dup(?)

devstrat proc far
	mov cs:word ptr[saveptr],bx
	mov cs:word ptr[saveptr+2],es
	ret
devstrat endp

devint  proc far
	pusha
	push ds
	push es
	lds bx,cs:[saveptr]
	mov [bx.IODAT.status],8103h
	cmp [bx.IODAT.cmd],00
	jnz devi1
	mov [bx.IODAT.status],0100h
	mov word ptr [bx+0eh],0000
	mov word ptr [bx+10h],cs
	xor dx,dx
	call main
devi1:
	pop ds
	pop es
	popa
	ret
devint  endp

endif

block1	db 00		;index
	db 5fh,4Fh,50h,82h,55h,81h
	db 0Bh,3eh,00h
	db 4Dh		; 9 max scan line
	db 0Ch,0Dh	;10 cursor start end
	db 00h,00h	;12 video start address
lblock1	equ $ - (block1 + 1)
block2	db 10h
	db 0eah,8ch,0dfh,28h,1fh,0e7h,04h
lblock2	equ $ - (block2 + 1)

putcrt proc
	lodsb
	.while (cl)
		mov ah,al
		lodsb
		xchg al,ah
		out dx,ax
		inc al
		dec cl
	.endw
	ret
putcrt endp

disablewp proc
	mov al,11h			;vertikal retrace end register bit 7 reset
	out dx,al			;= clear write protection for register 0-7
	inc dx
	in al,dx
	and al,7fh
	out dx,al
	dec dx
	ret
disablewp endp

enablewp proc
	mov al,11h
	out dx,al
	inc dx
	in al,dx
	or al,80h
	out dx,al
	dec dx
	ret
enablewp endp

getinpst1 proc				; get input status register 1
	mov dx,3cch
	in al,dx
	mov dx,3dah
	test al,1
	jnz @F
	mov dx,3bah
@@:
	ret
getinpst1 endp

clearscreen proc uses ds
	push 40h
	pop ds
	mov dx,0b800h
	mov ax,ds:[63h]
	cmp ax,3d4h
	jz @F
	mov dx,0b000h
@@:
	mov es,dx
	mov di,ds:[4eh]
	mov cx,ds:[4ch]
	shr cx,1
	mov ax,0720h
	rep stosw
	mov bh,ds:[62h]
	mov ah,02
	mov dx,0000
	int 10h
	ret
clearscreen endp

main proc c

local	bClear:word

	mov bClear,dx
	push cs
	pop ds
	assume ds:_TEXT

	push 40h
	pop es
	cmp word ptr es:[004Ah],80		;is screen in 80 col mode?
	jnz initmode
;-------------------------------------- make sure we are in text mode
	mov dx,3ceh						;graphics controller port
	mov al,6
	out dx,al
	inc dx
	in al,dx
	test al,1						;text mode on?
	jz @F
initmode:        
	mov ax,0003h					;if not, set standard text mode
	int 10h
@@:

	mov ax,1111h					;load 8x14 charset
	mov bl,0
	int 10h

;-------------------------------------- set BIOS variables
	push 0
	pop es
	mov word ptr es:[44Eh],0		;page start
	mov word ptr es:[460h],0C0Dh	;cursor form
	mov byte ptr es:[484h],ROWS-1	;max line#
	mov byte ptr es:[485h],14		;scan lines
	mov al,es:[044Ah]				;columns
	mov cl,ROWS*2
	mul cl
	mov word ptr es:[44ch],ax		;page size (ROWS * CULUMNS * size WORD)

;-------------------------------------- reprogram CRT controller
	cli
if 1
	mov dx,es:[463h]				;get crt address
	call disablewp
	mov si,offset block1
	mov cl,lblock1
	call putcrt
	mov si,offset block2
	mov cl,lblock2
	call putcrt
	call enablewp
endif
;-------------------------------------- write misc output register
	mov dx,3cch
	in al,dx
	and al,33h						;reset bits 2,3,6,7
	or al,0C0h						;set 480 scan lines, 25,175 MHz
	mov dx,3c2h						;has different output port!
	out dx,al

;-------------------------------------- write sequencer
	mov dx,3c4h
	mov al,1
	out dx,al
	inc dx
	mov ah,al
	in al,dx
	or al,1						;set dot clocks to 8
	out dx,al

	call getinpst1
	in al,dx					;reset attribute controller
	mov dx,3c0h

;-------------------------------------- write attribute controller

	mov al,13h					;select register
	out dx,al
	mov al,00h					;write new value
	out dx,al

	mov al,20h					;turn screen on again
	out dx,al

	sti

	.if (bClear)
		call clearscreen
	.else
		push 40h
		pop ds
		mov cx,ds:[4Ch]
		mov si,ds:[4Eh]
		mov ax,0B800h
		cmp byte ptr ds:[63h],0D4h
		jz @F
		mov ax,0B000h
@@:
		shr cx,1
		mov ds,ax
nextchar:
		lodsw
		cmp ah,0
		jnz @F
		mov ax,0720h
		mov [si-2],ax
@@:
		loop nextchar
	.endif

	mov al,00
	ret
main endp


astart:
;-------------------------------------- get cmdline parameter
	mov bx,80h
	mov cl,es:[bx]
	inc bx
	xor ax,ax
	xor dx,dx
	.while (cl)
		mov ah,al
		mov al,es:[bx]
		or al,20h
		.if ((ax == "/c") || (ax == "-c"))
			mov dl,1
		.endif
		inc bx
		dec cl
	.endw
	call main
	mov ah,4ch
	int 21h

	END astart
